//+------------------------------------------------------------------+ 
//|                                                         DEMA.mq4 | 
//|                                Double Exponential Moving Average | 
//|                              Linuxser :) contact me on FOREX-TSD |   
//|  The DEMA is a smoothing indicator with less lag than a straight |
//|  exponential moving average. DEMA is an acronym for Double       |
//|  Exponential Moving Average, but the calculation is more complex |
//|  than just a moving average of a moving average.                 |
//|  The DEMA was developed by Patrick Mulloy and is described in his|
//|  article in the February, 1994 issue of Technical Analysis of    |
//|  Stocks & Commodities magazine.                                  |
//|  Formula: (2 * n-day EMA) - (n-day EMA of EMA)                   |
//+------------------------------------------------------------------+ 
#property copyright "" 
#property link      "" 

#property indicator_chart_window 
#property indicator_buffers 1 

#property indicator_color1 LimeGreen
#property indicator_level1 0
#property indicator_width1 1

extern int EMA = 20,
           PeriodMode = 0, //0=close, 1=open, 2=high, 3=low, 4=median(high+low)/2, 5=typical(high+low+close)/3, 6=weighted(high+low+close+close)/4
           Shift = 0;
         
      
double 
      TS[],
      EMAbuffer[];

//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
  { 
   IndicatorBuffers(3);  

   IndicatorShortName("DEMA ("+EMA+")"); 
    
   SetIndexBuffer(0,TS);
   SetIndexBuffer(1,EMAbuffer);    
   
   SetIndexStyle(0, DRAW_LINE); 
   SetIndexShift(0,Shift);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   SetIndexStyle(1, DRAW_NONE);
   
   SetIndexDrawBegin(0,2); 
   SetIndexLabel(0,"DEMA");   
              
   return(0); 
  } 

//+------------------------------------------------------------------+ 
//| Custor indicator deinitialization function                       | 
//+------------------------------------------------------------------+ 
int deinit() 
  { 
   return(0); 
  } 

//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 
int start() 
  { 
   int   i, limit, counted_bars=IndicatorCounted(); 
               

//---- check for possible errors
   if(counted_bars<0) return(-1); 

//---- last counted bar will be recounted 
   if(counted_bars>0) counted_bars--; 

   limit=Bars-counted_bars; 

   for (i=limit-1; i>=0; i--) 
   EMAbuffer[i] = iMA(NULL,0,EMA,0,MODE_EMA,PeriodMode,i);   

//---- main indicator     
   for (i=limit-1; i>=0; i--) 
   TS[i] = 2 * iMA(NULL,0,EMA,0,MODE_EMA,PeriodMode,i) - iMAOnArray(EMAbuffer,0,EMA,0,MODE_EMA,i);

   return(0); 
  } 
//+------------------------------------------------------------------+ 

